-- Covert Operations Mission_Menu_Popup
-- Author: sman	
-- DateCreated: 12/21/17 9:07:48 AM
--------------------------------------------------------------

-- ===============================================================================================
--		includes

include("IconSupport")
include("InstanceManager")
include("InfoTooltipInclude")

include("00_Globals.lua")
include("20_Process_Mission_Results.lua")


-- ===============================================================================================
--		Globals

local g_ItemManager = InstanceManager:new( "ItemInstance", "Button", Controls.ItemStack )
local g_SelectedMission = ABORT_MISSION


-- ===============================================================================================
--		Support Functions

function DisplayPopup()	
	local pPlayer = Players[Game.GetActivePlayer()]
	local pUnit = UI.GetHeadSelectedUnit()
	local pPlot = pUnit:GetPlot()
	
	BuildValidMissionTable(pPlayer, pUnit, pPlot)
	g_ItemManager:ResetInstances()

	for num = 1, g_NumMissions do
		
		if g_ValidMissions[num][1] == YES then												-- Only load "valid" missions into the menu
		
			local controlTable = g_ItemManager:GetInstance()
			local iconIDX = num
						
			IconHookup( iconIDX+15, 64, "SMAN_COVERT_OPS_ACTION_ATLAS", controlTable.Icon64 )	-- Silver Icon at top of popup
			--IconHookup( iconIDX-1, 64, "SMAN_COVERT_OPS_ACTION_ATLAS", controlTable.Icon64 )	-- Gold Icon at top of popup

			local keyMissionTitleString = "TXT_KEY_COVERT_OPS_MISSION_TITLE_" .. num
			local keyMissionBodyString = "TXT_KEY_COVERT_OPS_MISSION_BODY_" .. num
		
			controlTable.Name:LocalizeAndSetText(keyMissionTitleString);
			controlTable.Button:SetToolTipString(Locale.ConvertTextKey(keyMissionBodyString, g_MissionList[num][2], g_MissionList[num][3], g_MissionList[num][4]));
			controlTable.Button:SetDisabled(false)				
		
			local selectionAnim = controlTable.SelectionAnim
			controlTable.Button:SetVoid1(num)
			controlTable.Button:RegisterCallback(Mouse.eLClick, function()  g_SelectedMission = num	DisplayPopup() end)		
		
			if g_SelectedMission then
				if g_SelectedMission == num then
					controlTable.SelectionAnim:SetHide(false)
				else
					controlTable.SelectionAnim:SetHide(true)
				end
			else
				controlTable.SelectionAnim:SetHide(true)
			end
		end 
	end

	Controls.ItemStack:CalculateSize()
	Controls.ItemStack:ReprocessAnchoring()
	Controls.ItemScrollPanel:CalculateInternalSize()
	Controls.ItemScrollPanel:SetScrollValue(0)
	Controls.ConfirmButton:SetDisabled(true)

	ContextPtr:SetHide(false)
	if g_SelectedMission then
		Controls.ConfirmButton:SetDisabled(false)
	end	
end


function OnConfirm()																		-- Process actions once the player has selected a mission
    ContextPtr:SetHide(true)																-- Hide the Menu Popup window
	--print("========> Selected mission: " .. g_SelectedMission .. "   for mission: " .. g_MissionList[g_SelectedMission][1])
	ProcessMission (g_SelectedMission)														-- Process the selected mission
	g_SelectedMission = ABORT_MISSION														-- Sets the default menu position to "Abort Mission" for the next time the popup unhides
end
Controls.ConfirmButton:RegisterCallback( Mouse.eLClick, OnConfirm )


function ShowCovertMissionPopup()
	DisplayPopup()
end 
LuaEvents.CovertMissionPopup.Add( ShowCovertMissionPopup )


function OnActivePlayerChanged( iActivePlayer, iPrevActivePlayer )
	if (not ContextPtr:IsHidden()) then
		ContextPtr:SetHide(true)
	end
end
Events.GameplaySetActivePlayer.Add(OnActivePlayerChanged)

--UIManager:QueuePopup(ContextPtr, PopupPriority.SocialPolicy)
UIManager:DequeuePopup(ContextPtr)